# Copyright 2014, Trimble Navigation Limited

# Copyright 2018, By SOFTDEG di Traini Tiziano Certaldo (FI) ITALIA

# se usato in ambito professionale è gradita una donazione 
# PayPal : tiziano.traini@tin.it

# This software is provided as an example of using the Ruby interface
# to SketchUp.

# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

#-----------------------------------------------------------------------------
# Name        :   SOFTDEG_Sguanci 1.2.0
# Description :   Un plugin per creare Sguanci Architettonici parametrici.
# Menu Item   :   Tools->SOFTDEG_Sguanci
# Context Menu:   Edit SOFTDEG_Sguanci
# Usage       :   Rileva o immetti dimensioni poi immetti le caratteristiche di uno sguancio
#             :   Per le modifiche successive tasto destro sullo sguancio e 
#             :   selezionare Edita SOFTDEG_Sguanci
# Date        :   31/10/2018
# Type        :   Web Dialog
#-----------------------------------------------------------------------------
# Classes for creating and editing parametric sguanci

require "sketchup.rb"
require "extensions.rb"

module SOFTDEG
  module SOFTDEG_Sguanci

    # Create the extension.
    loader = File.join(File.dirname(__FILE__), "SOFTDEG_Sguanci", "sguanci.rb")
    extension = SketchupExtension.new("SOFTDEG_Sguanci Tool", loader)
    extension.description = "Un plugin per creare Sguanci Architettonici parametrici"
    extension.version     = "1.2.0"
    extension.creator     = "SketchUp-SOFTDEG"
    extension.copyright   = "2014-2018, Trimble N.L. and " <<
                            "SOFTDEG - Tiziano Traini"

    # Register the extension with so it show up in the Preference panel.
    Sketchup.register_extension(extension, true)

  end # module SOFTDEG_Sguanci
end # module SOFTDEG
