# Copyright 2014, Trimble Navigation Limited

# Copyright 2018, By SOFTDEG di Traini Tiziano Certaldo (FI) ITALIA

# se usato in ambito professionale è gradita una donazione 
# PayPal : tiziano.traini@tin.it

# This software is provided as an example of using the Ruby interface
# to SketchUp.

# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

#-----------------------------------------------------------------------------
# Name        :   SOFTDEG_Sguanci 1.2.0
# Description :   Un plugin per creare Sguanci Architettonici parametrici.
# Menu Item   :   Tools->SOFTDEG_Sguanci
# Context Menu:   Edit SOFTDEG_Sguanci
# Usage       :   Rileva o immetti dimensioni poi immetti le caratteristiche di uno sguancio
#             :   Per le modifiche successive tasto destro sullo sguancio e 
#             :   selezionare Edita SOFTDEG_Sguanci
# Date        :   31/10/2018
# Type        :   Web Dialog
#-----------------------------------------------------------------------------
# Classes for creating and editing parametric sguanci

require "sketchup.rb"
File.join(File.dirname(__FILE__), 'parametric.rb').inspect
require File.join(File.dirname(__FILE__), 'parametric.rb')

# Show the Ruby Console at startup so we can
# see any programming errors we may make.
# Sketchup.send_action "showRubyPanel:"

module SOFTDEG::SOFTDEG_Sguanci

# Define the main parametric sguanci class
class SOFTDEG_Sguanci < Parametric

def SDset_dialog()
			
	default_html = File.dirname(__FILE__) + "/SOFTDEG_sguanci_languages/SOFTDEG_sguanci-en-US.html"
	dlghtml = "/SOFTDEG_sguanci_languages/SOFTDEG_sguanci-"+Sketchup.get_locale+".html"
	html = File.dirname(__FILE__) + dlghtml
	@SDdlg = @@SDdlg unless @SDdlg
	(Dir[html]==[]) ? (@SDdlg.set_file(default_html)) : (@SDdlg.set_file(html))
	
	@SDdlg.show_modal
	sleep(0.3)
	SDval_to_dialog()
		
end #end SDset_dialog
	
 

def SDval_to_dialog()

	dataval = [@@width, @@height, @@giraMis, @@intradosso_e, @@intradosso_i, @@spessore_f, @@prof_inc_f, @@dx_si, @@dx_se, @@sx_si, @@sx_se, @@top_si, @@top_se, @@bot_si, @@bot_se, @@dav_spe, @@dav_spi, @@dav_th, @@dav_types, @@dav_i, @@remove_v ]
	
	@@idset.each_with_index do |id,i|
		value = dataval[i].to_s
		js = "document.getElementById(\"#{id}\").value='#{value}'"
		@SDdlg.execute_script(js)
	end

	@@a_giraMis = "0" unless @@a_giraMis=="1"
	@@a_remove_v = "0" unless @@a_remove_v=="1"
	@@a_dav_types = "0" unless @@a_dav_types=="1"
	
	#option menu a discesa
		js = "document.getElementById(\"g\")[0] = new Option('0','0'"
		if @@a_giraMis=="0"
			js += ",true,true"
		end
		js += ");"
		@SDdlg.execute_script(js)

		js = "document.getElementById(\"g\")[1] = new Option('1','1'"
		if @@a_giraMis=="1"
			js += ",true,true"
		end
		js += ");"
		@SDdlg.execute_script(js)

		js = "document.getElementById(\"r\")[0] = new Option('0','0'"
		if @@a_remove_v=="0"
			js += ",true,true"
		end
		js += ");"
		@SDdlg.execute_script(js)

		js = "document.getElementById(\"r\")[1] = new Option('1','1'"
		if @@a_remove_v=="1"
			js += ",true,true"
		end
		js += ");"
		@SDdlg.execute_script(js)
	
		js = "document.getElementById(\"t\")[0] = new Option('0','0'"
		if @@a_dav_types=="0"
			js += ",true,true"
		end
		js += ");"
		@SDdlg.execute_script(js)

		js = "document.getElementById(\"t\")[1] = new Option('1','1'"
		if @@a_dav_types=="1"
			js += ",true,true"
		end
		js += ");"
		@SDdlg.execute_script(js)
	# end option menu a discesa
	
end #end val_to_dialog


def SDsubmit()
		
	@values = {}
	@@idset.each {|id| @values[id] = @SDdlg.get_element_value(id)}
	
	@@a_width = @values["w"].to_l
	@@a_height = @values["h"].to_l
	@@a_giraMis = @values["g"]
	@@a_intradosso_e = @values["ie"].to_l 
	@@a_intradosso_i = @values["ii"].to_l 
	@@a_spessore_f = @values["sf"].to_l 
	@@a_prof_inc_f = @values["pif"].to_l
	@@a_dx_si = @values["dx_si"].to_l 
	@@a_dx_se = @values["dx_se"].to_l
	@@a_sx_si = @values["sx_si"].to_l 
	@@a_sx_se = @values["sx_se"].to_l 
	@@a_top_si = @values["top_si"].to_l 
	@@a_top_se = @values["top_se"].to_l 
	@@a_bot_si = @values["bot_si"].to_l
	@@a_bot_se = @values["bot_se"].to_l 
	@@a_dav_spe = @values["dav_spe"].to_l 
	@@a_dav_spi = @values["dav_spi"].to_l 
	@@a_dav_th = @values["dav_th"].to_l 
	@@a_dav_types = @values["t"]
	@@a_dav_i = @values["dav_i"].to_l 
	@@a_remove_v = @values["r"]
		
	@@a_ok=1
  
	@SDdlg.close()
	
end #end submit

def _initialize

	@@a_width = @@width
	@@a_height = @@height
	@@a_giraMis = @@giraMis
	@@a_intradosso_e = @@intradosso_e
	@@a_intradosso_i = @@intradosso_i 
	@@a_spessore_f = @@spessore_f
	@@a_prof_inc_f = @@prof_inc_f
	@@a_dx_si = @@dx_si
	@@a_dx_se = @@dx_se
	@@a_sx_si = @@sx_si 
	@@a_sx_se = @@sx_se
	@@a_top_si = @@top_si 
	@@a_top_se = @@top_se
	@@a_bot_si = @@bot_si
	@@a_bot_se = @@bot_se
	@@a_dav_spe = @@dav_spe
	@@a_dav_spi = @@dav_spi
	@@a_dav_th = @@dav_th
	@@a_dav_types = @@dav_types
	@@a_dav_i = @@dav_i
	@@a_remove_v = @@remove_v
		
	@@a_ok=0
	
	@SDdlg = @@SDdlg
		
	@SDdlg.add_action_callback("submit")	{|d,p| SDsubmit()}
	@SDdlg.add_action_callback("close")		{|d,p| @SDdlg.close() }
	@SDdlg.add_action_callback("populate")	{|d,p| SDval_to_dialog() }
		
	SDset_dialog()

end #end _initialize



def default_parameters

	# Set other starting defaults if none set
	if !defined? @@a_width
		defaults = {
		"w" => 1000.mm, 
		"h" => 1440.mm, 
		"g" => 0, 
		"ie" => 150.mm, 
		"ii" => 300.mm, 
		"sf" => 70.mm, 
		"pif" => 70.mm, 
		"dx_si" => 90.mm, 
		"dx_se" => 320.mm, 
		"sx_si" => 90.mm, 
		"sx_se" => 320.mm, 
		"top_si" => 90.mm, 
		"top_se" => 320.mm, 
		"bot_si" => 0.mm, 
		"bot_se" => 0.mm, 
		"dav_spe" => 40.mm, 
		"dav_spi" => 40.mm, 
		"dav_th" => 40.mm, 
		"t" => 0, 
		"dav_i" => 230.mm, 
		"r" => 0}
	else
		# Reuse last inputs as defaults
		defaults = {
		"w" => @@width,
		"h" => @@height, 
		"g" => @@giraMis, 
		"ie" => @@intradosso_e, 
		"ii" => @@intradosso_i, 
		"sf" => @@spessore_f, 
		"pif" => @@prof_inc_f, 
		"dx_si" => @@dx_si, 
		"dx_se" => @@dx_se, 
		"sx_si" => @@sx_si, 
		"sx_se" => @@sx_se, 
		"top_si" => @@top_si, 
		"top_se" => @@top_se, 
		"bot_si" => @@bot_si, 
		"bot_se" => @@bot_se, 
		"dav_spe" => @@dav_spe, 
		"dav_spi" => @@dav_spi, 
		"dav_th" => @@dav_th, 
		"t" => @@dav_types, 
		"dav_i" => @@dav_i, 
		"r" => @@remove_v}
	end 
	
end # default_parameters


def prompt(operation)

	# get the parameters
	if( @entity )
		data = self.parameters
	else
		data = self.default_parameters
	end
		
	if( not data )
		puts "No parameters connected with the entity"
		return nil
	else
		@@width = data["w"]
		@@height = data["h"]
		@@giraMis = data["g"]
		@@intradosso_e = data["ie"]
		@@intradosso_i = data["ii"]
		@@spessore_f = data["sf"]
		@@prof_inc_f = data["pif"]
		@@dx_si = data["dx_si"]
		@@dx_se = data["dx_se"]
		@@sx_si = data["sx_si"]
		@@sx_se = data["sx_se"]
		@@top_si = data["top_si"]
		@@top_se = data["top_se"]
		@@bot_si = data["bot_si"]
		@@bot_se = data["bot_se"]
		@@dav_spe = data["dav_spe"]
		@@dav_spi = data["dav_spi"]
		@@dav_th = data["dav_th"]
		@@dav_types = data["t"]
		@@dav_i = data["dav_i"]
		@@remove_v = data["r"]
  end
		
  title = operation + " " + short_class_name
	
	# Se esiste una selezione attiva ne ricava le dimensioni
	@model = Sketchup.active_model
	@entities = @model.active_entities
	@sel=@model.selection
	
	faces = @sel.grep(Sketchup::Face) 
		
	if not @sel.empty? || faces.empty?
		
		@sel_ok=1 # semaforo selezione corretta
		
		@face = faces[0]
		@norm=@face.normal
						
		v0 = @face.edges[0]
		if v0.reversed_in?(@face)
			@cambiavert=1
		end
		v1 = @face.edges[1]
		v2 = @face.edges[2]
		v3 = @face.edges[3]
		v00=v0.vertices[0]
		v01=v0.vertices[1]
		v20=v2.vertices[0]
		v21=v2.vertices[1]
		v10=v1.vertices[0]
		v11=v1.vertices[1]
		v30=v3.vertices[0]
		v31=v3.vertices[1]
		
		# controlla se la prima riga è orizzontale rispetto all'asse z (trattandosi di infissi prevalentemente su pareti verticali)
		if v00.position.z == v01.position.z
		  @@width=v0.length
			@@height=v1.length  
			if v00.position.z < v20.position.z
				@i_point=v00
				@a_point=v01
				@as_point=v20
				@is_point=v21
			else
				@i_point=v20
				@a_point=v21
				@as_point=v00
				@is_point=v01
			end
		else
			@@height=v0.length
			@@width=v1.length  
			if v10.position.z < v30.position.z
				@i_point=v10
				@a_point=v11
				@as_point=v30
				@is_point=v31
			else
				@i_point=v30
				@a_point=v31
				@as_point=v10
				@is_point=v11
			end
		end
		
		data["w"] = @@width
		data["h"] = @@height
		@@a_width = @@width
		@@a_height = @@height
		@@giraMis = 0
		data["g"] = @@giraMis
		@@a_giraMis = @@giraMis
			
	end # fine lettura selezione
	
	if @sel.empty? or faces.length==1 or operation=="Edit"
	
	  @@a_ok=0 #reimposta semaforo submit
	
		@@idset = %w(w h g ie ii sf pif dx_si dx_se sx_si sx_se top_si top_se bot_si bot_se dav_spe dav_spi dav_th t dav_i r)
		@@SDdlg = UI::WebDialog.new(title,false,"SOFTDEG_SguanciDialog",920,720,20,20,true)
		_initialize()

		# verifica informazioni per disegnare le velette degli sguanci
		@@a_width = 50.mm unless @@a_width > 50.mm 
		@@a_height = 50.mm unless @@a_height > 50.mm 
		@@a_intradosso_e = 10.mm unless @@a_intradosso_e > 10.mm 
		
		if @@a_intradosso_i < @@a_spessore_f
			@@a_intradosso_i = @@a_spessore_f
			@@a_bot_se = 0.mm
			@@a_bot_si = 0.mm
		else
			if @@a_dav_i == 0
				@@a_dav_i = (@@a_intradosso_i - @@a_spessore_f).to_l
			end
		end
		
		if @@a_intradosso_i == @@a_spessore_f
			@@a_bot_se = 0.mm
			@@a_bot_si = 0.mm
		end
		
		@@a_spessore_f = 10.mm unless @@a_spessore_f > 10.mm 
		@@a_prof_inc_f = 10.mm unless @@a_prof_inc_f > 10.mm 
		@@a_dav_spe = 0.mm unless @@a_dav_spe > 0 
		@@a_dav_spi = 0.mm unless @@a_dav_spi > 0 
		@@a_dav_th = 0.mm unless @@a_dav_th > 0 
		@@a_dav_i = (@@a_intradosso_i - @@a_spessore_f).to_l unless @@a_dav_i < (@@a_intradosso_i - @@a_spessore_f).to_l
		
		if @@a_dx_si < @@a_prof_inc_f
			@@a_dx_si = (@@a_prof_inc_f+20.mm).to_l
		end
		if @@a_sx_si < @@a_prof_inc_f
			@@a_sx_si = (@@a_prof_inc_f+20.mm).to_l
		end
		if @@a_top_si < @@a_prof_inc_f
			@@a_top_si = (@@a_prof_inc_f+20.mm).to_l
		end
		
		@@a_bot_si = 0.mm unless @@a_bot_si > 0 
		@@a_bot_se = 0.mm unless @@a_bot_se > 0 
	
		if @@a_dx_se < @@a_dx_si
			@@a_dx_se = @@a_dx_si
		end
		if @@a_sx_se < @@a_sx_si
			@@a_sx_se = @@a_sx_si
		end
		if @@a_top_se < @@a_top_si
			@@a_top_se = @@a_top_si
		end
		if @@a_bot_se < @@a_bot_si
			@@a_bot_se = @@a_bot_si
		end	 
		
		# Store the results back into data
		if @@a_ok == 1 # Se è stato selezionato applica
			data["w"] = @@a_width
			data["h"] = @@a_height
			data["g"] = @@a_giraMis
			data["ie"] = @@a_intradosso_e
			data["ii"] = @@a_intradosso_i
			data["sf"] = @@a_spessore_f
			data["pif"] = @@a_prof_inc_f
			data["dx_si"] = @@a_dx_si
			data["dx_se"] = @@a_dx_se
			data["sx_si"] = @@a_sx_si
			data["sx_se"] = @@a_sx_se
			data["top_si"] = @@a_top_si
			data["top_se"] = @@a_top_se
			data["bot_si"] = @@a_bot_si
			data["bot_se"] = @@a_bot_se
			data["dav_spe"] = @@a_dav_spe
			data["dav_spi"] = @@a_dav_spi 
			data["dav_th"] = @@a_dav_th
			data["t"] = @@a_dav_types
			data["dav_i"] = @@a_dav_i 
			data["r"] = @@a_remove_v 
			data
		end
	else
		UI.messagebox("Select a single face and Repeat")
		return nil
	end
	
end # end prompt

def self.create

		sguanci = SOFTDEG_Sguanci.new
		defn = sguanci.entity
		if not defn == nil
		  Sketchup.active_model.place_component(defn, true, false, true)
		end

end # end self.create

def create_entity(model)

  @entity = @model.definitions.add("SOFTDEG_Sguanci")
  # Set the behavior
  behavior = @entity.behavior
  behavior.is2d = true
  behavior.snapto = 0
  behavior.cuts_opening = true
  @entity
  # Se esiste una faccia selezionata procede al posizionamento del componente
  if @sel_ok==1 # Se la selezione è valida
	
		if @cambiavert==1
			@t_i_point=@i_point
			@t_is_point=@is_point
			@i_point=@a_point
			@is_point=@as_point
			@a_point=@t_i_point
			@as_point=@t_is_point
		end
		
		if @@a_giraMis == "1"
			@t_i_point=@i_point
			@t_as_point=@as_point
			@i_point=@is_point
			@as_point=@a_point
			@is_point=@t_as_point
			@a_point=@t_i_point
			transformation = Geom::Transformation.new(@as_point, @norm)
		else
			transformation = Geom::Transformation.new(@i_point, @norm)
		end
		
		instance = @entities.add_instance(@entity, transformation)
		
		norm=@face.normal	# determina il vettore normale alla faccia iniziale
	  vector_h = Geom::Vector3d.new(@i_point.position,@is_point.position) # vettore su asse altezza
		vector_w = Geom::Vector3d.new(@a_point.position,@i_point.position) # vettore su asse larghezza
		norm90_w= norm.cross(vector_h) # determina il vettore perpendicolare alla normale alla faccia iniziale quindi sulla faccia nel senso della larghezza
		norm90_h= norm.cross(vector_w) # determina il vettore perpendicolare alla normale alla faccia iniziale quindi sulla faccia nel senso dell'altezza
		
		@face.erase!

		if @@a_giraMis == "1"
		
			fin_d_a=@@a_intradosso_e
			for_d_a=@@a_intradosso_e+@@a_intradosso_i
			fin_d_top=-@@a_dav_th
			fin_d_bot=0
			for_d_top=@@a_bot_se
			for_d_bot=@@a_top_se
			for_d_dx=@@a_sx_se
			for_d_sx=@@a_dx_se
		else

			# imposta i due offset per la faccia su cui calcolare l'infisso modifica dei punti inferiori in considerazione della presenza della soglia
			# impostamento dello spostamento assiale per posizionare la superficie sul punto interno dell'intradosso esterno
			fin_d_bot=@@a_dav_th
			fin_d_top=0
			fin_d_a=@@a_intradosso_e
			# imposta i quattro sfalzamenti (sguanci) per creare la superficie di foratura sulla parete interna oltre allo spostamento assiale dello spessore del muro
			for_d_top=@@a_top_se
			for_d_bot=@@a_bot_se
			for_d_dx=@@a_dx_se
			for_d_sx=@@a_sx_se
			for_d_a=@@a_intradosso_e+@@a_intradosso_i
		
		end
		
		inestra=sup_app(@i_point,@a_point,@as_point,@is_point,fin_d_top,-fin_d_bot,0,0,fin_d_a,norm,norm90_w,norm90_h,"off")
				
		foratura=sup_app(@i_point,@a_point,@as_point,@is_point,for_d_top,for_d_bot,for_d_dx,for_d_sx,for_d_a,norm,norm90_w,norm90_h,"on")
		
  end
	
end #end create_entity

def sup_app(i_point,a_point,as_point,is_point,d_top,d_bot,d_dx,d_sx,d_a,norm,norm90_w,norm90_h,remove)

		i_point=i_point.position
		a_point=a_point.position
		is_point=is_point.position
		as_point=as_point.position
		
		i_point=i_point.offset(norm90_h,+d_bot)
		a_point=a_point.offset(norm90_h,+d_bot)
		is_point=is_point.offset(norm90_h,-d_top)
		as_point=as_point.offset(norm90_h,-d_top)
	
		i_point = i_point.offset(norm, -d_a)
		a_point = a_point.offset(norm, -d_a)
		is_point = is_point.offset(norm, -d_a)
		as_point = as_point.offset(norm, -d_a)
		
		i_point = i_point.offset(norm90_w, d_sx)
		a_point = a_point.offset(norm90_w, -d_dx)
		is_point = is_point.offset(norm90_w, d_sx)
		as_point = as_point.offset(norm90_w, -d_dx)
		
		edges = []
			edges[0]=@entities.add_line i_point, a_point
			edges[1]=@entities.add_line a_point, as_point
			edges[2]=@entities.add_line as_point, is_point
			edges[3]=@entities.add_line is_point, i_point
			outer = @entities.add_face edges
		edges
		if remove =="on"
			outer.erase!
		end
	
end #def

def create_entities(data, container)
  
	# Definisce i tre materiali utilizzati
	mats=@model.materials
	if mats["facciata_01"]==nil
		esterno=mats.add("facciata_01")
		esterno.color="Green"
	end#if
	if mats["intonaco_01"]==nil
		interno=mats.add("intonaco_01")
		interno.color="Gray"
	end#if
	if mats["soglia_01"]==nil
		soglia=mats.add("soglia_01")
		soglia.color="Yellow"
	end#if
	
	# Set values from input data
	w = @@a_width
	h = @@a_height
	g = @@a_giraMis
	ie = @@a_intradosso_e 
	ii = @@a_intradosso_i 
	sf = @@a_spessore_f 
	pif = @@a_prof_inc_f
	dx_si = @@a_dx_si
	dx_se = @@a_dx_se
	sx_si = @@a_sx_si 
	sx_se = @@a_sx_se 
	top_si = @@a_top_si
	top_se = @@a_top_se 
	bot_si = @@a_bot_si
	bot_se = @@a_bot_se 
	dav_spe = @@a_dav_spe 
	dav_spi = @@a_dav_spi 
	dav_th = @@a_dav_th 
	t = @@a_dav_types 
	dav_i = @@a_dav_i
	r = @@a_remove_v
	
	# Remember values for next use
	@@width = w
  @@height = h
	@@giraMis = g
	@@intradosso_e = ie
	@@intradosso_i = ii
	@@spessore_f = sf
	@@prof_inc_f = pif
	@@dx_si = dx_si
	@@dx_se = dx_se
	@@sx_si = sx_si
	@@sx_se = sx_se
	@@top_si = top_si
	@@top_se = top_se
	@@bot_si = bot_si
	@@bot_se = bot_se
	@@dav_spe = dav_spe
	@@dav_spi = dav_spi
	@@dav_th = dav_th
	@@dav_types = t
	@@dav_i = dav_i
	@@remove_v = r
	
	# Draw
	create_sguancio(w, h, g, ie, ii, sf, pif, dx_si, dx_se, sx_si, sx_se, top_si, top_se, bot_si, bot_se, dav_spe, dav_spi, dav_th, t, dav_i, r, container)
	
end #end create_entities

# Crea una faccia rettangolare ad una specifica locazione
def rectangle(origin, width, height, asse, container, close)
  if asse == "yx" or asse == "xy"
		v1 = Geom::Vector3d.new(width,0,0)
		v2 = Geom::Vector3d.new(0,height,0)
	else
		if asse == "xz"
			v1 = Geom::Vector3d.new(width,0,0)
			v2 = Geom::Vector3d.new(0,0,height)
		else
			# asse == "yz"
			v1 = Geom::Vector3d.new(0,width,0)
			v2 = Geom::Vector3d.new(0,0,height)
		end
	end
		
  p1 = origin;
  p2 = origin + v1
  p3 = p2 + v2
  p4 = origin + v2
	
  edges = []
	if asse =="yx"
		edges[0]=container.add_line p1, p4
		edges[1]=container.add_line p4, p3
		edges[2]=container.add_line p3, p2
		edges[3]=container.add_line p2, p1
	else
		edges[0]=container.add_line p1, p2
		edges[1]=container.add_line p2, p3
		edges[2]=container.add_line p3, p4
		edges[3]=container.add_line p4, p1
	end

  if( close )
    f = container.add_face edges
	else
    edges
  end
	
end #end rectangle

# Crea una faccia a C ad una specifica locazione
def c_face(origin, width, height, dxWidth, sxWidth, topWidth, nome_mat, container, close)
    
  frame = container.add_group
  group_container = frame.entities
	
  l_rel = width-dxWidth
  h_rel = height-topWidth
	
  v1 = Geom::Vector3d.new(width,0,0)
  v2 = Geom::Vector3d.new(0,height,0)
  v3 = Geom::Vector3d.new(sxWidth,0,0)
  v4 = Geom::Vector3d.new(l_rel,0,0)
  v5 = Geom::Vector3d.new(0,h_rel,0)
  
  p1 = origin;
  p2 = origin + v1
  p3 = p2 + v2
  p4 = origin + v2
  p5 = origin + v3
  p6 = origin + v4
  p7 = p6 + v5
  p8 = p5 + v5
  
  edges = []
  edges[0]=group_container.add_line p1, p4
  edges[1]=group_container.add_line p4, p3
  edges[2]=group_container.add_line p3, p2
  edges[3]=group_container.add_line p2, p6
  edges[4]=group_container.add_line p6, p7
  edges[5]=group_container.add_line p7, p8
  edges[6]=group_container.add_line p8, p5
  edges[7]=group_container.add_line p5, p1

  if( close )
    outer = group_container.add_face edges
		status = outer.material = nome_mat
	else
    edges
  end
  frame
	
end #end c_face

# Crea una faccia asimmetrica ad O (cornice) ad una specifica locazione
def as_face(origin, width, height, dxWidth,  sxWidth, topWidth, botWidth, nome_mat, container)

  frame = container.add_group
	
  p1 = origin;
  v = Geom::Vector3d.new(sxWidth, botWidth, 0)
  p2 = p1 + v
	
  holeWidth = width - (dxWidth + sxWidth )
  holeHeight = height - (topWidth + botWidth)
		
  # Crea il pannello esterno ed il foro
  outer = rectangle(p1, width, height, "yx", frame.entities, true)
  status = outer.material = nome_mat
  
  hole = rectangle(p2, holeWidth, holeHeight, "yx", frame.entities, true)
  hole.erase!

  frame
	
end #end as_face

# Crea velette
def ase_face(origin, width, height, thickness, d_dxWidth, d_sxWidth, d_topWidth, d_botWidth, nome_mat, close_off, container)
    
  frame = container.add_group
	
  l_e = width + d_dxWidth + d_sxWidth	
  h_e = height + d_topWidth + d_botWidth
	
  v1 = Geom::Vector3d.new(width,0,0)
  v2 = Geom::Vector3d.new(0,height,0)
  v3 = Geom::Vector3d.new(-d_sxWidth,0,0)
  v4 = Geom::Vector3d.new(0,-d_botWidth,0)
  v5 = Geom::Vector3d.new(-d_sxWidth+l_e,0,0)
  v6 = Geom::Vector3d.new(0,-d_botWidth+h_e,0)
  v7 = Geom::Vector3d.new(0,0,thickness)	
		
  p1 = origin;
  p2 = origin + v1
  p3 = origin + v1 + v2
  p4 = origin + v2
	
  p5 = origin + v3 + v4 - v7
  p6 = origin + v4 + v5 - v7
  p7 = origin + v5 + v6 - v7
  p8 = origin + v3 + v6 - v7
	
  # bottom edge
  if  close_off == false  
    draw_line(p1, p2, p6, p5, nome_mat, frame.entities, true)
  end

  # dx edge
  draw_line(p2, p3, p7, p6, nome_mat, frame.entities, true)
		
  # top edge
  draw_line(p4, p8, p7, p3, nome_mat, frame.entities, true)
	
  # sx edge
  draw_line(p1, p5, p8, p4, nome_mat, frame.entities, true)
	
  frame
	
end #end ase_face

# Crea velette 2
def ase_face2(origin, d_soglia, width, height, bot_si, thickness, thickness2, d_dxWidth, d_sxWidth, d_dxWidth2, d_sxWidth2, d_topWidth, d_botWidth, nome_mat, close_off, container)
    
  frame = container.add_group
	
  l_e = width + d_dxWidth + d_sxWidth	
  h_e = height + d_topWidth
	
  l_i2 = width + d_dxWidth2 + d_sxWidth2	
  h_e2 = bot_si + d_botWidth
	
  v0 = Geom::Vector3d.new(0,d_soglia,0)
  v1 = Geom::Vector3d.new(width,0,0)
  v2 = Geom::Vector3d.new(0,height,0)
		
  v3 = Geom::Vector3d.new(-d_sxWidth,0,0)
  v4 = Geom::Vector3d.new(0,-h_e2,0)
  v5 = Geom::Vector3d.new(l_e-d_sxWidth,0,0)
  v6 = Geom::Vector3d.new(0,h_e,0)
  v7 = Geom::Vector3d.new(0,0,thickness)	
	
  v8 = Geom::Vector3d.new(-d_sxWidth2,0,0)
  v9 = Geom::Vector3d.new(l_i2-d_sxWidth2,0,0)
  v10 = Geom::Vector3d.new(0,0,thickness2)
	
  v11 = Geom::Vector3d.new(0,-bot_si,0)
	
  p1 = origin;
  p0 = origin + v0
  p2 = origin + v1 + v0
  p3 = origin + v1 + v2
  p4 = origin + v2
	
  p5 = origin + v3 + v4 - v7
  p6 = origin + v4 + v5 - v7
  p7 = origin + v5 + v6 - v7
  p8 = origin + v3 + v6 - v7
	
  p9 = origin + v0 + v8 - v10
  p10 = origin + v8 + v11 - v10
  p11 = origin + v9 + v11 - v10
  p12 = origin + v9 + v0 - v10
	
  # bottom edge
  if close_off == false 
    draw_line(p10, p11, p6, p5, nome_mat, frame.entities, true)
  end
  
  # top edge
  draw_line(p4, p8, p7, p3, nome_mat, frame.entities, true)
	
  # dx edge
  draw_line6(p2, p3, p7, p6, p11, p12, nome_mat, frame.entities, true)
	
  # sx edge
  draw_line6(p0, p9, p10, p5, p8, p4, nome_mat, frame.entities, true)
		
  frame
	
end #end ase_face2

# Crea una faccia per 4 punti tramite linee
def draw_line(p1, p2, p3, p4,  nome_mat, container, close)
	
  frame = container.add_group	
  
  edges = []
  edges[0]=container.add_line p1, p2
  edges[1]=container.add_line p2, p3
  edges[2]=container.add_line p3, p4
  edges[3]=container.add_line p4, p1

  if( close )
    outer = container.add_face edges
		status = outer.material = nome_mat
  else
    edges
  end
  frame
	
end #end draw_line

# Crea una faccia per 6 punti tramite linee
def draw_line6(p1, p2, p3, p4, p5, p6,  nome_mat, container, close)
	
  frame = container.add_group	
  
  edges = []
  edges[0]=container.add_line p1, p2
  edges[1]=container.add_line p2, p3
  edges[2]=container.add_line p3, p4
  edges[3]=container.add_line p4, p5
  edges[4]=container.add_line p5, p6
  edges[5]=container.add_line p6, p1

  if( close )
    outer = container.add_face edges
		status = outer.material = nome_mat
  else
    edges
  end
	
  frame
	
end #end draw_line6

# Crea una anello di facce (tubo)
def draw_tubeface(origin, width, height, thickness, nome_mat, container)
	
  frame = container.add_group
   
  outer=rectangle(origin, width, thickness, "xz", frame.entities, true)
  status = outer.material = nome_mat
	
  origin.x=origin.x+width
  outer=rectangle(origin,height,thickness, "yz", frame.entities, true)
  status = outer.material = nome_mat
	
  origin.y=origin.y+height
  outer=rectangle(origin, -width,thickness, "xz", frame.entities, true)
  status = outer.material = nome_mat
	
  origin.x=origin.x-width
  outer=rectangle(origin,-height,thickness, "yz", frame.entities, true)
  status = outer.material = nome_mat
	
  origin.y=origin.y-height

  frame
	
end #end draw_tubeface

# Crea Soglia Davanzale
def dav_face(origin, dav_spe, dav_spi, dav_th, dav_types,  width, intradosso_e, intradosso_i, prof_inc_f, spessore_f, dx_si, dx_se, sx_si, sx_se, nome_mat, container, close)
  
  dav_types = 1 unless intradosso_i > spessore_f
	
  if dav_spi > intradosso_i
		d_dav_spi = dav_spi - intradosso_i
	else
		d_dav_spi = 0
	end	
	  
  frame = container.add_group
  group_container = frame.entities
	
	v1 = Geom::Vector3d.new(0,0,-intradosso_e)
  v2 = Geom::Vector3d.new(0,0,-(intradosso_e + spessore_f))
  v3 = Geom::Vector3d.new(0,0,-(intradosso_e + intradosso_i))
  v4 = Geom::Vector3d.new(0,0,+dav_spe)
  v5 = Geom::Vector3d.new(-dav_spe,0,0)
  v6 = Geom::Vector3d.new(-prof_inc_f,0,0)
  v7 = Geom::Vector3d.new(-sx_si,0,0)
  v8 = Geom::Vector3d.new(-sx_se,0,0)
  v9 = Geom::Vector3d.new(width + dx_se,0,0)
  v10 = Geom::Vector3d.new(width + dx_si,0,0)
  v11 = Geom::Vector3d.new(width + prof_inc_f,0,0)
  v12 = Geom::Vector3d.new(width,0,0)
  v13 = Geom::Vector3d.new(width + dav_spe,0,0)
	v14 = Geom::Vector3d.new(-(sx_se + d_dav_spi),0,0)
	v15 = Geom::Vector3d.new(width + dx_se + d_dav_spi ,0,0)
	v16 = Geom::Vector3d.new(0,0,-(intradosso_e + intradosso_i + d_dav_spi))
	
  p1 = origin;
  p2 = origin + v1
  p3 = origin + v1 + v6
  p4 = origin + v2 + v6 
  p5 = origin + v2 + v7
  p6 = origin + v3 + v8
  p7 = origin + v3 + v9
  p8 = origin + v2 + v10
  p9 = origin + v2 + v11
  p10 = origin + v1 + v11
  p11 = origin + v1 + v12
  p12 = origin + v12
	# punti sporgenza esterna
 	p13 = origin + v13
	p14 = origin + v4 + v13
	p15 = origin + v4 + v5
	p16 = origin + v5
	# punti sporgenza esterna
	p17 = origin + v14 + v3
	p18 = origin + v14 + v16
	p19 = origin + v15 + v16
	p20 = origin + v15 + v3
  	
  if dav_types == 0
  
		edges = []
		if d_dav_spi > 0 # la sporgenza interna è maggiore dell'intradosso interno
			
				edges[0]=group_container.add_line p1, p2
				edges[1]=group_container.add_line p2, p3
				edges[2]=group_container.add_line p3, p4
				edges[3]=group_container.add_line p4, p5
				edges[4]=group_container.add_line p5, p6
				edges[5]=group_container.add_line p6, p17
				edges[6]=group_container.add_line p17, p18
				edges[7]=group_container.add_line p18, p19
				edges[8]=group_container.add_line p19, p20
				edges[9]=group_container.add_line p20, p7
				edges[10]=group_container.add_line p7, p8
				edges[11]=group_container.add_line p8, p9
				edges[12]=group_container.add_line p9, p10
				edges[13]=group_container.add_line p10, p11
				edges[14]=group_container.add_line p11, p12
				if dav_spe > 0
					edges[15]=group_container.add_line p12, p13
					edges[16]=group_container.add_line p13, p14
					edges[17]=group_container.add_line p14, p15
					edges[18]=group_container.add_line p15, p16
					edges[19]=group_container.add_line p16, p1
				else
					edges[15]=group_container.add_line p12, p1
				end
			
		else

			edges[0]=group_container.add_line p1, p2
			edges[1]=group_container.add_line p2, p3
			edges[2]=group_container.add_line p3, p4
			edges[3]=group_container.add_line p4, p5
			edges[4]=group_container.add_line p5, p6
			edges[5]=group_container.add_line p6, p7
			edges[6]=group_container.add_line p7, p8
			edges[7]=group_container.add_line p8, p9
			edges[8]=group_container.add_line p9, p10
			edges[9]=group_container.add_line p10, p11
			edges[10]=group_container.add_line p11, p12
		
			if dav_spe > 0
				edges[11]=group_container.add_line p12, p13
				edges[12]=group_container.add_line p13, p14
				edges[13]=group_container.add_line p14, p15
				edges[14]=group_container.add_line p15, p16
				edges[15]=group_container.add_line p16, p1
			else
				edges[11]=group_container.add_line p12, p1
			end
		end
		if( close )
			outer = group_container.add_face edges
			status = outer.material = nome_mat
    else
			edges
		end
		
		frame
		outer.reverse!
		outer.pushpull(dav_th)

  else # tipo sovrapposta
		edges = []
		edges[0]=group_container.add_line p1, p2
		edges[1]=group_container.add_line p2, p3
		edges[2]=group_container.add_line p3, p4
		edges[3]=group_container.add_line p4, p9
		edges[4]=group_container.add_line p9, p10
		edges[5]=group_container.add_line p10, p11
		edges[6]=group_container.add_line p11, p12
		
		if dav_spe >0
			edges[7]=group_container.add_line p12, p13
			edges[8]=group_container.add_line p13, p14
			edges[9]=group_container.add_line p14, p15
			edges[10]=group_container.add_line p15, p16
			edges[11]=group_container.add_line p16, p1
		else
			edges[7]=group_container.add_line p12, p1
		end
		
		edges1 = []
		if d_dav_spi > 0
			edges1[0]=group_container.add_line p8, p5
			edges1[1]=group_container.add_line p5, p6
			edges1[2]=group_container.add_line p6, p17
			edges1[3]=group_container.add_line p17, p18
			edges1[4]=group_container.add_line p18, p19
			edges1[5]=group_container.add_line p19, p20
			edges1[6]=group_container.add_line p20, p7
			edges1[7]=group_container.add_line p7, p8
			
		else
			edges1[0]=group_container.add_line p8, p5
			edges1[1]=group_container.add_line p5, p6
			edges1[2]=group_container.add_line p6, p7
			edges1[3]=group_container.add_line p7, p8
    end
		
		if( close )
			outer = group_container.add_face edges
			status = outer.material = nome_mat
			if intradosso_i > spessore_f
				outer1 = group_container.add_face edges1
				status1 = outer1.material = nome_mat
			end
		else
			edges
			edges1
		end
		
		frame
		outer.reverse!
		outer.pushpull(dav_th)
		
		if intradosso_i > spessore_f
			outer1.reverse!
			outer1.pushpull(dav_th*2,true)
			outer1.reverse!
			outer1.pushpull(-dav_th)
		end
  end
	
end #end dav_face

# Crea sella sottosoglia
def sella_face(origin, bot_si, d_soglia, width, intradosso_e, intradosso_i, prof_inc_f, spessore_f, dx_si, dx_se, sx_si, sx_se, nome_mat, container)
    
  frame = container.add_group
  group_container = frame.entities
			
  v1 = Geom::Vector3d.new(0,0,-intradosso_e)
  v2 = Geom::Vector3d.new(0,0,-(intradosso_e + spessore_f))
  v3 = Geom::Vector3d.new(0,0,-(intradosso_e + intradosso_i))
	
  v6 = Geom::Vector3d.new(-prof_inc_f,0,0)
  v7 = Geom::Vector3d.new(-sx_si,0,0)
  v8 = Geom::Vector3d.new(-sx_se,0,0)
  v9 = Geom::Vector3d.new(width + dx_se,0,0)
  v10 = Geom::Vector3d.new(width + dx_si,0,0)
  v11 = Geom::Vector3d.new(width + prof_inc_f,0,0)
  
  v14 = Geom::Vector3d.new(0,-bot_si,0)
  v15 = Geom::Vector3d.new(0,-d_soglia,0)
	
  p1 = origin;
	
  p4 = origin + v2 + v6 
	
  p5 = origin + v2 + v7
  p6 = origin + v3 + v8
  p7 = origin + v3 + v9
  p8 = origin + v2 + v10
	
  p9 = origin + v2 + v11
		
  p17 = origin + v3 +v8 +v14
  p18 = origin + v3 +v9 +v14
	
  p19 = origin + v2 +v6 +v15
  p20 = origin + v2 +v11 +v15
	
  draw_line6(p8, p7, p6, p5, p4, p9, nome_mat, frame.entities, true)
	
  draw_line(p6, p7, p18, p17, nome_mat, frame.entities, true)
  
	if not d_soglia == 0
		draw_line(p4, p9, p20, p19, nome_mat, frame.entities, true)
  end
	
  frame
		
end #end sella_face

# end def

#################################################################################################################################

# Crea lo sguancio
def create_sguancio(width, height, giraMis, intradosso_e, intradosso_i, spessore_f, prof_inc_f, dx_si, dx_se, sx_si, sx_se, top_si, top_se, bot_si, bot_se, dav_spe, dav_spi, dav_th, dav_types, dav_i, remove_v, container)

  #assegna valori alle variabili
  bNo = (giraMis == "0")
  bSi = (giraMis == "1")
  bPiana = (dav_types == "0")
  bSovrapposta = (dav_types == "1")
  d_soglia=0.mm
	
	#memorizza valori originali alle variabili 
	o_dav_spi=dav_spi
	o_intradosso_i=intradosso_i
	o_dx_se=dx_se
	o_sx_se=sx_se
	
  if remove_v == "0"
		close_off = false
  else
		close_off = true
  end
	
  w = width
  h = height
	
  # punto di inserimento esterno
  pt = Geom::Point3d.new(0,0,0)
		
  # chiede se le misure devono essere invertite
  if bSi
		h=width
		w=height
  end
	
  # memorizza le coordinate iniziali
  ptx=pt.x
  pty=pt.y
  ptz=pt.z
	
  # Rettangolo per forare la geometria
  # attenzione non si deve raggruppare altrimenti non funziona
  # la geometria deve coincidere con l'intero rettangolo o essere staccata, altrimenti la specchia
  rectangle(pt, w, h, "xy", container, false)
	
  # definisce un gruppo per le nuove entità
  frame = container.add_group
	
  # disegna le superfici dell'intradosso esterno fino all'infisso
  draw_tubeface(pt, w, h, -intradosso_e, "facciata_01", container)
	
  # determina le nuove coordinate
  pt.z=pt.z-intradosso_e
	
  # Superficie di posa per infisso
  #rectangle(pt, width, height, "xy", container, true)
	
  # determina le nuove coordinate
  pt.x=pt.x-prof_inc_f
	
  # disegna la sede del telaiaccio per l'infisso
  c_face(pt, (w+(2*prof_inc_f)), (h+prof_inc_f), prof_inc_f, prof_inc_f, prof_inc_f, "facciata_01",container, true)  
	
  draw_tubeface(pt, (w+(2*prof_inc_f)), (h+prof_inc_f), -spessore_f, "intonaco_01", container)
   
  # determina le nuove coordinate
  pt.x=pt.x-(sx_si-prof_inc_f)
  pt.y=pt.y-bot_si
  pt.z=pt.z-spessore_f

	if intradosso_i > spessore_f # determina se esiste uno spessore utile per la creazione degli sguanci 
  
		# disegna una cornice in base alle dimensioni interne dello sguancio
		if bot_si <= 0
			bot_si = 0
			c_face(pt, (w+dx_si+sx_si), (h+top_si), (dx_si-prof_inc_f), (sx_si-prof_inc_f),  (top_si-prof_inc_f), "intonaco_01",container, true)   
		else
			if dav_i >= (intradosso_i-spessore_f)
				dav_i= (intradosso_i-spessore_f)
				as_face(pt, (w+dx_si+sx_si), (h+top_si+bot_si), (dx_si-prof_inc_f), (sx_si-prof_inc_f),  (top_si-prof_inc_f), (bot_si), "intonaco_01",container)   
			else
				pt.y=pt.y+bot_si
				if bSovrapposta
					d_soglia=dav_th
					pt.y=pt.y+d_soglia
				else
					d_soglia=0.mm
				end
				
				c_face(pt, (w+dx_si+sx_si), (h+top_si-d_soglia), (dx_si-prof_inc_f), (sx_si-prof_inc_f),  (top_si-prof_inc_f), "intonaco_01",container, true)   
			
				dx_se_c = (((dx_se-dx_si)/(intradosso_i-spessore_f))*(intradosso_i-spessore_f-dav_i))+dx_si
				sx_se_c = (((sx_se-sx_si)/(intradosso_i-spessore_f))*(intradosso_i-spessore_f-dav_i))+sx_si
			
				intradosso_i_c = (intradosso_i-spessore_f-dav_i) + spessore_f
				
				# imposta le coordinate come in origine
				pt.x=ptx
				pt.y=pty
				pt.z=ptz
	  
				if bSovrapposta
					d_soglia=dav_th
					pt.y=pt.y+d_soglia
				else
					d_soglia=0.mm
				end
				
				sella_face(pt, bot_si+d_soglia, d_soglia, w, intradosso_e, intradosso_i_c, prof_inc_f, spessore_f, dx_si, dx_se_c, sx_si, sx_se_c, "intonaco_01", container)
			end
		end

		# disegna le velette degli sguanci
		if bSovrapposta
			if not bot_se >0
				d_soglia=dav_th
				pt.y=pt.y+d_soglia
			end
		else
			d_soglia=0.mm
		end
	
		if bot_se > 0
			if dav_i >= (intradosso_i-spessore_f)
				dav_i= (intradosso_i-spessore_f)
				ase_face(pt, (w+dx_si+sx_si), (h+top_si+bot_si-d_soglia), (intradosso_i-spessore_f),(dx_se-dx_si), (sx_se-sx_si),  (top_se-top_si), (bot_se-bot_si), "intonaco_01", close_off, container)
			else
				pt.x=ptx-sx_si
				pt.y=pty
				pt.z=ptz-(intradosso_e+spessore_f)
			
				ase_face2(pt, d_soglia, (w+dx_si+sx_si), (h+top_si), bot_si, (intradosso_i-spessore_f), (intradosso_i-spessore_f-dav_i), (dx_se-dx_si), (sx_se-sx_si), (dx_se_c-dx_si), (sx_se_c-sx_si), (top_se-top_si), (bot_se-bot_si), "intonaco_01", close_off, container)
			end
		else
			ase_face(pt, (w+dx_si+sx_si), (h+top_si+bot_si-d_soglia), (intradosso_i-spessore_f),(dx_se-dx_si), (sx_se-sx_si),  (top_se-top_si), (bot_se-bot_si), "intonaco_01", close_off, container)
		end
	end	
  
	# imposta le coordinate come in origine
  pt.x=ptx
  pt.y=pty
  pt.z=ptz
   
  # determina gli sfalsamenti in base alle dimensioni interne dello sguancio
  if bot_se > 0 and dav_spi <= dav_i
		
		dav_spi=(intradosso_i-spessore_f)-dav_i+dav_spi
		dx_se = (((dx_se-dx_si)/(intradosso_i-spessore_f))*dav_spi)+dx_si
		sx_se = (((sx_se-sx_si)/(intradosso_i-spessore_f))*dav_spi)+sx_si
		intradosso_i = dav_spi + spessore_f
	else
			if bot_se > 0
				dav_spi=(intradosso_i)-dav_i+dav_spi
			else
				dav_spi=dav_spi+o_intradosso_i
			end
			intradosso_i=o_intradosso_i
			dx_se=o_dx_se
			sx_se=o_sx_se
		
	end
	
	
  # disegna il davanzale se previsto (altezza positiva)
  if dav_th > 0
		if bPiana 
			dav_face(pt, dav_spe, dav_spi, dav_th, 0, w, intradosso_e, intradosso_i, prof_inc_f, spessore_f, dx_si, dx_se, sx_si, sx_se, "soglia_01", container, true)
		else
			dav_face(pt, dav_spe, dav_spi, dav_th, 1, w, intradosso_e, intradosso_i, prof_inc_f, spessore_f, dx_si, dx_se, sx_si, sx_se, "soglia_01", container, true)
		end
  end
	 
  
  
end	#def create_sguancio

end # class SOFTDEG_Sguanci

# add a menu 
unless file_loaded?(__FILE__)
  cmd1=UI::Command.new("SOFTDEG_Sguanci") { SOFTDEG_Sguanci.create } 
  cmd1.tooltip='Sguanci Architettonici Parametrici - donazione PayPal: tiziano.traini@tin.it'
  cmd1.status_bar_text='Sguanci Architettonici Parametrici: Seleziona una faccia o inizia da zero...'
  cmd1.small_icon=File.join(File.dirname(__FILE__), 'sguanci_16x16.png')
  cmd1.large_icon=File.join(File.dirname(__FILE__), 'sguanci_24x24.png')
	    
  menu=UI.menu("Tools").add_item(cmd1) 
  toolbar=UI::Toolbar.new('SOFTDEG_Sguanci')
  toolbar.add_item(cmd1)
  toolbar.restore if toolbar.get_last_state.abs==1 
  file_loaded(__FILE__)
end	

end # module SOFTDEG::SOFTDEG_Sguanci
